package cn.skcks.study.rxjava;

import io.reactivex.rxjava3.core.Flowable;
import io.reactivex.rxjava3.core.Observable;
import io.reactivex.rxjava3.core.ObservableOnSubscribe;
import io.reactivex.rxjava3.disposables.Disposable;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

@Slf4j
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.NONE)
public class RxJavaStudyStarterTest {
    @Test
    void contextLoads() {
      log.info("Hello, RxJava!");
        Disposable disposable = Flowable.just("Hello world").subscribe(System.out::println);
        disposable.dispose();

        Observable.create((ObservableOnSubscribe<Integer>) emitter -> {
            for (int i = 1; i <= 5; i++) {
                emitter.onNext(i);
            }
            emitter.onComplete();
        }).subscribe(item -> System.out.println("Next: " + item));

        Observable<Integer> take = Observable.fromArray(1, 2, 3, 4, 5).skip(2).take(1);
        take.subscribe(System.out::println);
    }
}
